#ifndef __MENU_H_
#define __MENU_H_

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <string.h>

#include "oss.h"

void menu_frame(void);
void menu_main(void);
void menu_inter(void);

void quit_rtdsp_menu(GtkWidget *, gpointer);
void configure_devices(GtkWidget *, gpointer);
void about(GtkWidget *, gpointer);
void ouvrir_callback(GtkWidget *, gpointer);
void enregistrer_callback(GtkWidget *, gpointer);
void repertoire_callback(GtkWidget *, gpointer);


void configure_devices_freq_11(GtkWidget *but, gpointer data);
void configure_devices_freq_22(GtkWidget *but, gpointer data);
void configure_devices_freq_44(GtkWidget *but, gpointer data);

void configure_devices_buf_64(GtkWidget *but, gpointer data);
void configure_devices_buf_128(GtkWidget *but, gpointer data);
void configure_devices_buf_256(GtkWidget *but, gpointer data);

void configure_devices_ok(GtkWidget *w, gpointer data);
void configure_devices_cancel(GtkWidget *w, gpointer data);

void quit_rtdsp_ok(GtkWidget *window, gpointer data);
void quit_rtdsp_cancel(GtkWidget *window, gpointer data);


#endif
