#ifndef __OSS_H_
#define __OSS_H_

#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <stdlib.h>

extern short int *process_buffer;
extern int sampling_frequency;
extern int sample_format;
extern int stereo;
extern int blocksize;
extern char sound_device_name[80];

int sound_start_playing(void);
void sound_stop_playing(void);
int sound_write(void);
int sound_read(void);

#endif
