#ifndef __PANNEAU_H_
#define __PANNEAU_H_

#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkrgb.h>
#include <dirent.h>
#include <memory.h>
#include <dlfcn.h>
#include <sys/stat.h>
#include <unistd.h>

//#include "plugin.h"
#include "pedale.h"
#include "moteur.h"

void panneau_frame(void);
void panneau_main(void);
void panneau_inter(int valeur);

void panneau_oscilloscope(void);
void panneau_liste(void);
void panneau_rack(void);

void select_row_add_list(GtkWidget *list, gint row, gint column, GdkEventButton *event, gpointer data);
void find_all_plugins(GtkWidget *list);

gchar *get_plugin_name(gchar *filename);


#endif
