#include "pedale.h"

GtkWidget *frame_pedale;

extern GtkWidget *Fenetre_Principale;
extern GtkWidget *fenetre_fixe;

GtkWidget *pedale_toolbar;
GtkWidget *pedale_1;
GtkWidget *pedale_2;
GtkWidget *pedale_3;
GtkWidget *pedale_4;
GtkWidget *frame_menu;
GtkWidget *vbox6;
GtkWidget *hbox11;
GtkWidget *label22;
GtkWidget *label18;
GtkWidget *label19;
GtkWidget *label20;
GtkWidget *label21;
GtkWidget *label23;
GtkWidget *tmp_toolbar_icon;

extern int mode;
extern int is_playing;

extern GtkWidget *list;
extern GtkWidget *plugin_list;


static GList *pixmaps_directories = NULL;


static char *dummy_pixmap_xpm[] = {
  "1 1 1 1",
  "  c None",
  " "
};

void pedale_frame(void)
{
  // La Frame Pedale

  frame_pedale = gtk_frame_new (NULL);
  gtk_widget_show (frame_pedale);
  gtk_fixed_put (GTK_FIXED (fenetre_fixe), frame_pedale, 0, 460);
  gtk_widget_set_uposition (frame_pedale, 0, 460);
  gtk_widget_set_usize (frame_pedale, 550, 140);

}

void pedale_main(void)
{
  pedale_frame();
  pedale_inter();
  label();
}

void pedale_inter(void)
{


  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_container_add (GTK_CONTAINER (frame_pedale), vbox6);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox6), hbox11, TRUE, TRUE, 0);

  label22 = gtk_label_new ("");
  gtk_widget_show (label22);
  gtk_box_pack_start (GTK_BOX (hbox11), label22, FALSE, FALSE, 0);
  gtk_widget_set_usize (label22, 15, -2);

  label18 = gtk_label_new ("");
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox11), label18, FALSE, FALSE, 0);
  gtk_widget_set_usize (label18, 130, -2);

  label19 = gtk_label_new ("");
  gtk_widget_show (label19);
  gtk_box_pack_start (GTK_BOX (hbox11), label19, FALSE, FALSE, 0);
  gtk_widget_set_usize (label19, 130, -2);

  label20 = gtk_label_new ("");
  gtk_widget_show (label20);
  gtk_box_pack_start (GTK_BOX (hbox11), label20, FALSE, FALSE, 0);
  gtk_widget_set_usize (label20, 130, -2);

  label21 = gtk_label_new ("");
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (hbox11), label21, FALSE, FALSE, 0);
  gtk_widget_set_usize (label21, 130, -2);

  label23 = gtk_label_new ("");
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (hbox11), label23, FALSE, FALSE, 0);
  gtk_widget_set_usize (label23, 15, -2);

  pedale_toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_show (pedale_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox6), pedale_toolbar, FALSE, FALSE, 0);
  gtk_widget_set_usize (pedale_toolbar, 550, 120);
  gtk_container_set_border_width (GTK_CONTAINER (pedale_toolbar), 14);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (pedale_toolbar), 0);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (pedale_toolbar), GTK_RELIEF_NONE);

  tmp_toolbar_icon = create_pixmap (Fenetre_Principale, "Pedale.xpm");
  pedale_1 = gtk_toolbar_append_element (GTK_TOOLBAR (pedale_toolbar),
					 GTK_TOOLBAR_CHILD_BUTTON,
					 NULL,
					 "",
					 NULL, NULL,
					 tmp_toolbar_icon, 
					 pedale1_callback, NULL);
  gtk_widget_show (pedale_1);
  gtk_widget_set_usize (pedale_1, 130, 120);

  tmp_toolbar_icon = create_pixmap (Fenetre_Principale, "Pedale.xpm");
  pedale_2 = gtk_toolbar_append_element (GTK_TOOLBAR (pedale_toolbar),
					 GTK_TOOLBAR_CHILD_BUTTON,
					 NULL,
					 "",
					 NULL, NULL,
					 tmp_toolbar_icon, 
					 pedale2_callback, NULL);
  gtk_widget_show (pedale_2);
  gtk_widget_set_usize (pedale_2, 130, 120);

  tmp_toolbar_icon = create_pixmap (Fenetre_Principale, "Pedale.xpm");
  pedale_3 = gtk_toolbar_append_element (GTK_TOOLBAR (pedale_toolbar),
					 GTK_TOOLBAR_CHILD_BUTTON,
					 NULL,
					 "",
					 NULL, NULL,
					 tmp_toolbar_icon, 
					 pedale3_callback, NULL);
  gtk_widget_show (pedale_3);
  gtk_widget_set_usize (pedale_3, 130, 120);

  tmp_toolbar_icon = create_pixmap (Fenetre_Principale, "Pedale.xpm");
  pedale_4 = gtk_toolbar_append_element (GTK_TOOLBAR (pedale_toolbar),
					 GTK_TOOLBAR_CHILD_BUTTON,
					 NULL,
					 "",
					 NULL, NULL,
					 tmp_toolbar_icon, 
					 pedale4_callback, NULL);
  gtk_widget_show (pedale_4);
  gtk_widget_set_usize (pedale_4, 130, 120);


}

GtkWidget*
create_pixmap                          (GtkWidget       *widget,
                                        const gchar     *filename)
{
  gchar *found_filename = NULL;
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmap;
  GList *elem;

  if (!filename || !filename[0])
    return create_dummy_pixmap (widget);

  elem = pixmaps_directories;
  while (elem)
    {
      found_filename = check_file_exists ((gchar*)elem->data, filename);
      if (found_filename)
        break;
      elem = elem->next;
    }

  if (!found_filename)
    {
      found_filename = check_file_exists ("./images", filename);
    }

  if (!found_filename)
    {
      g_warning ("Couldn't find pixmap file: %s", filename);
      return create_dummy_pixmap (widget);
    }

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm (NULL, colormap, &mask,
                                                   NULL, found_filename);
  if (gdkpixmap == NULL)
    {
      g_warning ("Error loading pixmap file: %s", found_filename);
      g_free (found_filename);
      return create_dummy_pixmap (widget);
    }
  g_free (found_filename);
  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}

GtkWidget*
create_dummy_pixmap                    (GtkWidget       *widget)
{
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmap;

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask,
                                                     NULL, dummy_pixmap_xpm);
  if (gdkpixmap == NULL)
    g_error ("Couldn't create replacement pixmap.");
  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}


gchar*
check_file_exists                      (const gchar     *directory,
                                        const gchar     *filename)
{
  gchar *full_filename;
  struct stat s;
  gint status;

  full_filename = (gchar*) g_malloc (strlen (directory) + 1
                                     + strlen (filename) + 1);
  strcpy (full_filename, directory);
  strcat (full_filename, G_DIR_SEPARATOR_S);
  strcat (full_filename, filename);

  status = stat (full_filename, &s);
  if (status == 0 && S_ISREG (s.st_mode))
    return full_filename;
  g_free (full_filename);
  return NULL;
}

void label(void)
{
  if (mode == 1)
    {
      gtk_label_set((GtkLabel *)label18 , "On / Off");
      gtk_label_set((GtkLabel *)label19 , "FFT / Courbe");
      gtk_label_set((GtkLabel *)label20 , "Entre");
      gtk_label_set((GtkLabel *)label21 , "Sortie");
    }
  
  else if (mode == 2)
    {
      gtk_label_set((GtkLabel *)label18 , "On / Off");
      gtk_label_set((GtkLabel *)label19 , "Ajouter");
      gtk_label_set((GtkLabel *)label20 , "Enlever");
      gtk_label_set((GtkLabel *)label21 , "Configurer");
    }
  
  else if (mode == 3)
    {
      gtk_label_set((GtkLabel *)label18 , "On / Off");
      gtk_label_set((GtkLabel *)label19 , "Pause");
      gtk_label_set((GtkLabel *)label20 , "Ajouter");
      gtk_label_set((GtkLabel *)label21 , "Enlever");
    }

}


void pedale1_callback(void)
{
  if (mode == 1)
    {
  
    }

  else if (mode == 2)
    {
      process_start_stop(pedale_1, label18);

    }

  else if (mode ==3)
    {
      list_start_stop(pedale_1, label18);

    }

}

void pedale2_callback(void)
{
  if (mode == 1)
    {

    }

  else if (mode == 2)
    {
      add_window_append(pedale_2, (gpointer)list);
    }

  else if (mode == 3)
    {

    }

}

void pedale3_callback(void)
{
  if (mode == 1)
    {

    }

  else if (mode == 2)
    {
      remove_plugin_from_list(pedale_3, plugin_list);
    }

  else if (mode == 3)
    {

    }

}

void pedale4_callback(void)
{
  if (mode == 1)
    {

    }

  else if (mode == 2)
    {
      configure_plugin(pedale_4, NULL);
    }

  else if (mode == 3)
    {

    }
}
