#ifndef __PEDALE_H_
#define __PEDALE_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <gtk/gtk.h>
#include <sys/stat.h>

//#include "moteur.h"

void pedale_frame(void);
void pedale_main(void);
void pedale_inter(void);
void label(void);

GtkWidget*  create_pixmap(GtkWidget       *widget, const gchar     *filename);
GtkWidget* create_dummy_pixmap(GtkWidget       *widget);
gchar* check_file_exists(const gchar     *directory, const gchar     *filename);

void pedale1_callback(void);
void pedale2_callback(void);
void pedale3_callback(void);
void pedale4_callback(void);

extern void add_window_append(GtkWidget *button, gpointer data);
extern void remove_plugin_from_list(GtkWidget *button, gpointer data);
extern void configure_plugin(GtkWidget *button, gpointer data);
extern void process_start_stop(GtkWidget *button, gpointer data);
extern void list_start_stop(GtkWidget *button, gpointer data);

#endif
